/* engine.c generated by valac 0.53.1, the Vala compiler
 * generated from engine.vala, do not modify */

/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */

#include "word-completion.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

enum  {
	EUCLIDE_COMPLETION_PARSER_0_PROPERTY,
	EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES
};
static GParamSpec* euclide_completion_parser_properties[EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _EuclideCompletionParserPrivate {
	GeeArrayList* words;
	GRecMutex __lock_words;
	gchar* last_word;
};

static gint EuclideCompletionParser_private_offset;
static gpointer euclide_completion_parser_parent_class = NULL;
static GType euclide_completion_parser_type_id = 0;

static void euclide_completion_parser_add_word (EuclideCompletionParser* self,
                                         const gchar* word);
static gboolean euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                                 const gchar* text);
static void euclide_completion_parser_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
euclide_completion_parser_get_instance_private (EuclideCompletionParser* self)
{
	return G_STRUCT_MEMBER_P (self, EuclideCompletionParser_private_offset);
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

gboolean
euclide_completion_parser_is_delimiter (EuclideCompletionParser* self,
                                        gunichar c)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = string_index_of_char (EUCLIDE_COMPLETION_PARSER_DELIMITERS, c, 0) >= 0;
	return result;
}

EuclideCompletionParser*
euclide_completion_parser_construct (GType object_type)
{
	EuclideCompletionParser * self = NULL;
	GeeHashMap* _tmp0_;
	self = (EuclideCompletionParser*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (gtk_text_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->text_view_words);
	self->text_view_words = _tmp0_;
	return self;
}

EuclideCompletionParser*
euclide_completion_parser_new (void)
{
	return euclide_completion_parser_construct (EUCLIDE_COMPLETION_TYPE_PARSER);
}

void
euclide_completion_parser_add_last_word (EuclideCompletionParser* self)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->last_word;
	euclide_completion_parser_add_word (self, _tmp0_);
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

gboolean
euclide_completion_parser_get_for_word (EuclideCompletionParser* self,
                                        const gchar* to_find,
                                        GeeTreeSet* * list)
{
	GeeTreeSet* _vala_list = NULL;
	guint length = 0U;
	gint _tmp0_;
	gint _tmp1_;
	GeeTreeSet* _tmp2_;
	gchar* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeTreeSet* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (to_find != NULL, FALSE);
	_tmp0_ = strlen (to_find);
	_tmp1_ = _tmp0_;
	length = (guint) _tmp1_;
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (_vala_list);
	_vala_list = _tmp2_;
	_tmp3_ = g_strdup (to_find);
	_g_free0 (self->priv->last_word);
	self->priv->last_word = _tmp3_;
	_tmp4_ = self->priv->words;
	if (_tmp4_ != NULL) {
		{
			GeeArrayList* _tmp5_;
			_tmp5_ = self->priv->words;
			g_rec_mutex_lock (&self->priv->__lock_words);
			{
				{
					GeeArrayList* _word_list = NULL;
					GeeArrayList* _tmp6_;
					gint _word_size = 0;
					GeeArrayList* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gint _word_index = 0;
					_tmp6_ = self->priv->words;
					_word_list = _tmp6_;
					_tmp7_ = _word_list;
					_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
					_tmp9_ = _tmp8_;
					_word_size = _tmp9_;
					_word_index = -1;
					while (TRUE) {
						gint _tmp10_;
						gint _tmp11_;
						gchar* word = NULL;
						GeeArrayList* _tmp12_;
						gpointer _tmp13_;
						gboolean _tmp14_ = FALSE;
						const gchar* _tmp15_;
						gint _tmp16_;
						gint _tmp17_;
						_word_index = _word_index + 1;
						_tmp10_ = _word_index;
						_tmp11_ = _word_size;
						if (!(_tmp10_ < _tmp11_)) {
							break;
						}
						_tmp12_ = _word_list;
						_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _word_index);
						word = (gchar*) _tmp13_;
						_tmp15_ = word;
						_tmp16_ = strlen (_tmp15_);
						_tmp17_ = _tmp16_;
						if (((guint) _tmp17_) > length) {
							const gchar* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
							_tmp18_ = word;
							_tmp19_ = string_slice (_tmp18_, (glong) 0, (glong) length);
							_tmp20_ = _tmp19_;
							_tmp14_ = g_strcmp0 (_tmp20_, to_find) == 0;
							_g_free0 (_tmp20_);
						} else {
							_tmp14_ = FALSE;
						}
						if (_tmp14_) {
							GeeTreeSet* _tmp21_;
							const gchar* _tmp22_;
							_tmp21_ = _vala_list;
							_tmp22_ = word;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
						}
						_g_free0 (word);
					}
				}
			}
			__finally0:
			{
				GeeArrayList* _tmp23_;
				_tmp23_ = self->priv->words;
				g_rec_mutex_unlock (&self->priv->__lock_words);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp24_ = FALSE;
				_g_object_unref0 (_vala_list);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp24_;
			}
		}
	}
	_tmp25_ = _vala_list;
	_tmp26_ = gee_collection_get_is_empty ((GeeCollection*) _tmp25_);
	_tmp27_ = _tmp26_;
	result = !_tmp27_;
	if (list) {
		*list = _vala_list;
	} else {
		_g_object_unref0 (_vala_list);
	}
	return result;
}

void
euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self,
                                             GtkTextView* view)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->words;
		g_rec_mutex_lock (&self->priv->__lock_words);
		{
			GeeArrayList* _tmp1_;
			_tmp1_ = self->priv->words;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
		}
		__finally0:
		{
			GeeArrayList* _tmp2_;
			_tmp2_ = self->priv->words;
			g_rec_mutex_unlock (&self->priv->__lock_words);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	euclide_completion_parser_parse_text_view (self, view);
}

void
euclide_completion_parser_parse_text_view (EuclideCompletionParser* self,
                                           GtkTextView* view)
{
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->words;
		g_rec_mutex_lock (&self->priv->__lock_words);
		{
			GeeHashMap* _tmp1_;
			_tmp1_ = self->text_view_words;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, view)) {
				GeeHashMap* _tmp2_;
				gpointer _tmp3_;
				_tmp2_ = self->text_view_words;
				_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, view);
				_g_object_unref0 (self->priv->words);
				self->priv->words = (GeeArrayList*) _tmp3_;
			} else {
				GeeArrayList* _tmp4_;
				_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
				_g_object_unref0 (self->priv->words);
				self->priv->words = _tmp4_;
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp5_;
			_tmp5_ = self->priv->words;
			g_rec_mutex_unlock (&self->priv->__lock_words);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp6_ = gtk_text_view_get_buffer (view);
	_tmp7_ = _tmp6_;
	g_object_get (_tmp7_, "text", &_tmp8_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_;
	_tmp11_ = strlen (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_ > 0;
	_g_free0 (_tmp10_);
	if (_tmp13_) {
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GeeHashMap* _tmp19_;
		GeeArrayList* _tmp20_;
		_tmp14_ = gtk_text_view_get_buffer (view);
		_tmp15_ = _tmp14_;
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		euclide_completion_parser_parse_string (self, _tmp18_);
		_g_free0 (_tmp18_);
		_tmp19_ = self->text_view_words;
		_tmp20_ = self->priv->words;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, view, _tmp20_);
	}
}

static void
euclide_completion_parser_add_word (EuclideCompletionParser* self,
                                    const gchar* word)
{
	gint _tmp0_;
	gint _tmp1_;
	GeeArrayList* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (word != NULL);
	_tmp0_ = strlen (word);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH) {
		return;
	}
	_tmp2_ = self->priv->words;
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, word)) {
		{
			GeeArrayList* _tmp3_;
			_tmp3_ = self->priv->words;
			g_rec_mutex_lock (&self->priv->__lock_words);
			{
				GeeArrayList* _tmp4_;
				_tmp4_ = self->priv->words;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, word);
			}
			__finally0:
			{
				GeeArrayList* _tmp5_;
				_tmp5_ = self->priv->words;
				g_rec_mutex_unlock (&self->priv->__lock_words);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

void
euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self)
{
	g_return_if_fail (self != NULL);
	self->parsing_cancelled = TRUE;
}

static gboolean
euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                        const gchar* text)
{
	gchar** word_array = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint word_array_length1;
	gint _word_array_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (text != NULL, FALSE);
	self->parsing_cancelled = FALSE;
	_tmp1_ = _tmp0_ = g_strsplit_set (text, EUCLIDE_COMPLETION_PARSER_DELIMITERS, EUCLIDE_COMPLETION_PARSER_MAX_TOKENS);
	word_array = _tmp1_;
	word_array_length1 = _vala_array_length (_tmp0_);
	_word_array_size_ = word_array_length1;
	_tmp2_ = word_array;
	_tmp2__length1 = word_array_length1;
	{
		gchar** current_word_collection = NULL;
		gint current_word_collection_length1 = 0;
		gint _current_word_collection_size_ = 0;
		gint current_word_it = 0;
		current_word_collection = _tmp2_;
		current_word_collection_length1 = _tmp2__length1;
		for (current_word_it = 0; current_word_it < current_word_collection_length1; current_word_it = current_word_it + 1) {
			gchar* _tmp3_;
			gchar* current_word = NULL;
			_tmp3_ = g_strdup (current_word_collection[current_word_it]);
			current_word = _tmp3_;
			{
				const gchar* _tmp4_;
				if (self->parsing_cancelled) {
					g_debug ("engine.vala:105: Cancelling parse");
					result = FALSE;
					_g_free0 (current_word);
					word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_tmp4_ = current_word;
				euclide_completion_parser_add_word (self, _tmp4_);
				_g_free0 (current_word);
			}
		}
	}
	result = TRUE;
	word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
euclide_completion_parser_class_init (EuclideCompletionParserClass * klass,
                                      gpointer klass_data)
{
	euclide_completion_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &EuclideCompletionParser_private_offset);
	G_OBJECT_CLASS (klass)->finalize = euclide_completion_parser_finalize;
}

static void
euclide_completion_parser_instance_init (EuclideCompletionParser * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
	self->priv = euclide_completion_parser_get_instance_private (self);
	self->parsing_cancelled = FALSE;
	g_rec_mutex_init (&self->priv->__lock_words);
	_tmp0_ = g_strdup ("");
	self->priv->last_word = _tmp0_;
}

static void
euclide_completion_parser_finalize (GObject * obj)
{
	EuclideCompletionParser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser);
	_g_object_unref0 (self->text_view_words);
	g_rec_mutex_clear (&self->priv->__lock_words);
	_g_object_unref0 (self->priv->words);
	_g_free0 (self->priv->last_word);
	G_OBJECT_CLASS (euclide_completion_parser_parent_class)->finalize (obj);
}

GType
euclide_completion_parser_get_type (void)
{
	return euclide_completion_parser_type_id;
}

GType
euclide_completion_parser_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (EuclideCompletionParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) euclide_completion_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EuclideCompletionParser), 0, (GInstanceInitFunc) euclide_completion_parser_instance_init, NULL };
	euclide_completion_parser_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "EuclideCompletionParser", &g_define_type_info, 0);
	EuclideCompletionParser_private_offset = sizeof (EuclideCompletionParserPrivate);
	return euclide_completion_parser_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

